package edu.lawrence.sqltournament;

import java.io.IOException;
import java.net.URL;
import java.util.List;
import java.util.ResourceBundle;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.ListView;
import javafx.scene.control.TextField;

public class PrimaryController implements Initializable {
    TournamentDAO dao;
    @FXML ListView activeMatches;
    @FXML ListView leaderBoard;
    @FXML TextField nameField;
    
    @FXML
    private void register() {
        // Put logic here to register this new player with the dao
        refreshLists();
    }

    @FXML
    private void oneWins() {
        Match m = (Match) activeMatches.getSelectionModel().getSelectedItem();
        // Put logic here to use the dao to record the winner of this match
        refreshLists();
    }
    
    @FXML
    private void twoWins() {
        Match m = (Match) activeMatches.getSelectionModel().getSelectedItem();
        // Put logic here to use the dao to record the winner of this match
        refreshLists();
    }
    
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        dao = new TournamentDAO();
        refreshLists();
    }
    
    private void refreshLists() {
        leaderBoard.getItems().clear();
        List<Player> players = dao.getAllPlayers();
        leaderBoard.getItems().addAll(players);
        activeMatches.getItems().clear();
        List<Match> matches = dao.getActiveMatches();
        activeMatches.getItems().addAll(matches);
    }
}
