package edu.lawrence.sqltournament;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

public class TournamentDAO {
    private Connection connection;
    private Statement statement;
    private String playerSQL = "select name, played, wins from players where name=?";
    private PreparedStatement playerStmt;
    private String allPlayersSQL = "select name, played, wins from players order by wins desc";
    private PreparedStatement allPlayersStmt;
    private String matchesSQL ="select * from matches where winner is null";
    private PreparedStatement matchesStmt;
    // Declare any additional prepared statements you will need here
    
    public TournamentDAO() {
        try {
            Class.forName("com.mysql.cj.jdbc.Driver");
        } catch (ClassNotFoundException ex) {
            System.out.println("Could not load database driver.");
        }
        try {
            connection = DriverManager.getConnection("jdbc:mysql://localhost:3306/tournament?user=student&password=Cmsc250!");
            playerStmt = connection.prepareStatement(playerSQL);
            allPlayersStmt = connection.prepareStatement(allPlayersSQL);
            matchesStmt = connection.prepareStatement(matchesSQL);
        } catch (SQLException ex) {
            System.out.println("Could not connect to database.");
            ex.printStackTrace();
        }
        
    }
    
    public List<Player> getAllPlayers() {
        ArrayList<Player> results = new ArrayList<Player>();
        try {
            ResultSet rst = allPlayersStmt.executeQuery();
            while(rst.next()) {
                Player p = new Player();
                p.setName(rst.getString("name"));
                p.setPlayed(rst.getInt("played"));
                p.setWins(rst.getInt("wins"));
                results.add(p);
            }
        } catch(SQLException ex) {
            ex.printStackTrace();
        }
        return results;
    }
    
    public List<Match> getActiveMatches() {
        ArrayList<Match> results = new ArrayList<Match>();
        try {
            ResultSet rst = matchesStmt.executeQuery();
            while(rst.next()) {
                Match m = new Match();
                m.setId(rst.getInt("idmatches"));
                m.setPlayerOne(rst.getString("playerOne"));
                m.setPlayerTwo(rst.getString("playerTwo"));
                results.add(m);
            } 
        } catch(SQLException ex) {
            ex.printStackTrace();
        }
        return results;
    }
    
    // Add additional methods as needed to help you register
    // new players and record winners of matches.
}
